searchNodes=[{"ref":"Mix.Tasks.GitHooks.Install.html","title":"Mix.Tasks.GitHooks.Install","type":"task","doc":"Installs the configured git hooks. Before installing the new hooks, the already hooks files are backed up with the extension .pre_git_hooks_backup. Command line options --quiet - disables the output of the files that are beeing copied/backed up To manually install the git hooks run: mix git_hooks.install"},{"ref":"Mix.Tasks.GitHooks.Run.html","title":"Mix.Tasks.GitHooks.Run","type":"task","doc":"Runs all the configured mix tasks for a given git hook. Any git hook is supported. Examples You can run any hook by running mix git_hooks.run hook_name. For example: mix git_hooks.run pre_commit You can also all the hooks which are configured with mix git_hooks.run all."},{"ref":"Mix.Tasks.GitHooks.Run.html#run/1","title":"Mix.Tasks.GitHooks.Run.run/1","type":"function","doc":"Runs a task for a given git hook. The task can be one of three different types: {:cmd, &quot;command arg1 arg2&quot;}: Runs a command. {:file, &quot;path_to_file&quot;}: Runs an executable file. &quot;command arg1 arg2&quot;: Runs a simple command, supports no options. The first two options above can use a third element in the tuple, see here more info about the options."},{"ref":"Mix.Tasks.GitHooks.Run.html#t:git_hook_args/0","title":"Mix.Tasks.GitHooks.Run.git_hook_args/0","type":"opaque","doc":""},{"ref":"Mix.Tasks.GitHooks.Run.html#t:run_opts/0","title":"Mix.Tasks.GitHooks.Run.run_opts/0","type":"type","doc":"Run options: include_hook_args: Whether the git hook args should be sent to the command to be executed. In case of true, the args will be amended to the command. Defaults to false."},{"ref":"readme.html","title":"GitHooks","type":"extras","doc":"GitHooks Installs git hooks that will run in your Elixir project. Any git hook type is supported, check here the hooks list."},{"ref":"readme.html#table-of-contents","title":"GitHooks - Table of Contents","type":"extras","doc":"Installation Backup current hooks Automatic installation Manual installation Configuration Example config Type of tasks Command Executable file Removing a hook Execution Automatic execution Manual execution"},{"ref":"readme.html#installation","title":"GitHooks - Installation","type":"extras","doc":"Add to dependencies: def deps do [{:git_hooks, &quot;~&gt; 0.4.1&quot;, only: [:test, :dev], runtime: false}] end Then install and compile the dependencies: mix deps.get &amp;&amp; mix deps.compile Backup current hooks This project will backup automatically your the hook files that are going to be overwrite. The backup files will have the file extension .pre_git_hooks_backup. Automatic installation This library will install automatically the configured git hooks in your config.exs file. Manual installation You can manually install the configured git hooks at any time by running: mix git_hooks.install"},{"ref":"readme.html#configuration","title":"GitHooks - Configuration","type":"extras","doc":"One or more git hooks can be configured, those hooks will be the ones installed in your git project. Currently there are supported two configuration options: tasks: A list of the commands that will be executed when running a git hook. See types of tasks for more info. verbose: If true, the output of the mix tasks will be visible. This can be configured globally or per git hook. Example config In config/config.exs if Mix.env() != :prod do config :git_hooks, verbose: true, hooks: [ pre_commit: [ tasks: [ &quot;mix format&quot; ] ], pre_push: [ verbose: false, tasks: [ &quot;mix dialyzer&quot;, &quot;mix test&quot;, &quot;echo &#39;success!&#39;&quot; ] ] ] end Type of tasks Command To run a simple command you can either declare a string or a tuple with the command you want to run. For example, having &quot;mix test&quot; and {:cmd, &quot;mix test&quot;} in the hook tasks will be equivalent. If you want to forward the git hook arguments, add the option include_hook_args: true. config :git_hooks, verbose: true, hooks: [ commit_msg: [ tasks: [ {:cmd, &quot;echo &#39;test&#39;&quot;}, {:cmd, &quot;elixir ./priv/test_task.ex&quot;, include_hook_args: true}, ] ] ] Executable file The following configuration uses a script file to be run with a git hook. If you want to forward the git hook arguments, add the option include_hook_args: true. config :git_hooks, verbose: true, hooks: [ commit_msg: [ tasks: [ {:file, &quot;./priv/test_script&quot;}, {:file, &quot;./priv/test_script_with_args&quot;, include_hook_args: true}, ] ] ] The script file executed will receive the arguments from git, so you can use them as you please."},{"ref":"readme.html#removing-a-hook","title":"GitHooks - Removing a hook","type":"extras","doc":"When a git hook configuration is removed, the installed hook will automatically delete it. Any backup done at the moment will still be kept."},{"ref":"readme.html#execution","title":"GitHooks - Execution","type":"extras","doc":"Automatic execution The configured mix tasks will run automatically for each git hook. Manual execution You can also run manually any configured git hook as well. The following example will run the pre_commit configuration: mix git_hooks.run pre_commit It is also possible to run all the configured hooks: mix git_hooks.run all"}]